#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from zephir.monitor.agentmanager.templates.PageTmpl import PageTmpl
from zephir.monitor.agentmanager import status

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0.1'
__CHEETAH_versionTuple__ = (2, 0, 1, 'final', 0)
__CHEETAH_genTime__ = 1428926582.8630049
__CHEETAH_genTimestamp__ = 'Mon Apr 13 14:03:02 2015'
__CHEETAH_src__ = 'AgentPageTmpl.tmpl'
__CHEETAH_srcLastModified__ = 'Mon Apr 13 14:02:56 2015'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class AgentPageTmpl(PageTmpl):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        PageTmpl.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<!-- AgentPageTmpl #encoding utf-8 -->

''')
        _v = VFFSL(SL,"head",False)(VFFSL(SL,"agent.name",True) + " &ndash; " + VFFSL(SL,"hostname",True)) # '$head($agent.name + " &ndash; " + $hostname)' on line 5, col 1
        if _v is not None: write(_filter(_v, rawExpr='$head($agent.name + " &ndash; " + $hostname)')) # from line 5, col 1.
        write('''

<SCRIPT LANGUAGE="JavaScript">
<!--
function clear() {
        location.reload(false)
}
setTimeout ("clear()", 60000);
// -->
</SCRIPT>

''')
        if VFFSL(SL,"agent.description",True) is not None and VFFSL(SL,"len",False)(VFFSL(SL,"agent.description",True)) != 0: # generated from line 16, col 1
            write('''<h1 id="title">''')
            _v = VFFSL(SL,"agent.description",True) # '$agent.description' on line 17, col 16
            if _v is not None: write(_filter(_v, rawExpr='$agent.description')) # from line 17, col 16.
            write('''</h1>
''')
        else: # generated from line 18, col 1
            write('''<h1 id="title">''')
            _v = VFFSL(SL,"agent.name",True) # '$agent.name' on line 19, col 16
            if _v is not None: write(_filter(_v, rawExpr='$agent.name')) # from line 19, col 16.
            write('''</h1>
''')
        write('''
<div id="nav">
  <!-- FIXME need to get that from AgentResource
''')
        siblings = []
        section = ""
        if VFFSL(SL,"len",False)(VFFSL(SL,"siblings",True)) != 0: # generated from line 26, col 3
            write('''  Section ''')
            _v = VFFSL(SL,"section",True) # '$section' on line 27, col 11
            if _v is not None: write(_filter(_v, rawExpr='$section')) # from line 27, col 11.
            write(''' :
''')
        write('''   -->
  <ol>
''')
        if VFFSL(SL,"show_clients",True) == True: # generated from line 31, col 5
            write('''      <li><a href="/agents/">Clients</a></li>
''')
        write('''    <li><a href="/agents/''')
        _v = VFFSL(SL,"host",True) # '$host' on line 34, col 26
        if _v is not None: write(_filter(_v, rawExpr='$host')) # from line 34, col 26.
        write('''/">Retour</a></li>
''')
        for a in VFFSL(SL,"siblings",True): # generated from line 35, col 2
            write('''    <li><a href="./''')
            _v = VFFSL(SL,"a",True) # '$a' on line 36, col 20
            if _v is not None: write(_filter(_v, rawExpr='$a')) # from line 36, col 20.
            write('''/">''')
            _v = VFFSL(SL,"a",True) # '$a' on line 36, col 25
            if _v is not None: write(_filter(_v, rawExpr='$a')) # from line 36, col 25.
            write('''</a></li>
''')
        write('''  </ol>
</div> <!-- nav -->

<div id="side">
    <div class="right_status">
''')
        if VFFSL(SL,"agent.name",True) == "bilan": # generated from line 43, col 7
            write('''        <img src="./status_long.png"/>
''')
        else: # generated from line 45, col 7
            write('''        <img src="./status.png"/>
''')
        write('''    </div>
    <div class="left_status">
''')
        s = VFFSL(SL,"agent.last_status",True)
        max = VFFSL(SL,"agent.max_status",True)
        write('''\t    \xc3\x89tat&nbsp;:&nbsp;<span class="status-''')
        _v = VFFSL(SL,"s.level",True) # '$s.level' on line 52, col 44
        if _v is not None: write(_filter(_v, rawExpr='$s.level')) # from line 52, col 44.
        write('''">''')
        _v = VFFSL(SL,"str",False)(VFFSL(SL,"s",True)) # '$str($s)' on line 52, col 54
        if _v is not None: write(_filter(_v, rawExpr='$str($s)')) # from line 52, col 54.
        write('''</span><br/>
\t    Date de la mesure&nbsp;:&nbsp;''')
        _v = VFFSL(SL,"agent.last_measure_date",True) # '$agent.last_measure_date' on line 53, col 36
        if _v is not None: write(_filter(_v, rawExpr='$agent.last_measure_date')) # from line 53, col 36.
        write('''<br/>
''')
        if VFFSL(SL,"max",True) != VFN(VFFSL(SL,"status",True),"Unknown",False)(): # generated from line 55, col 6
            write('''              Dernier probl\xc3\xa8me&nbsp;(<span class="status-''')
            _v = VFFSL(SL,"max.level",True) # '$max.level' on line 56, col 59
            if _v is not None: write(_filter(_v, rawExpr='$max.level')) # from line 56, col 59.
            write('''">''')
            _v = VFFSL(SL,"str",False)(VFFSL(SL,"max",True)) # '$str($max)' on line 56, col 71
            if _v is not None: write(_filter(_v, rawExpr='$str($max)')) # from line 56, col 71.
            write('''</span>)&nbsp;:&nbsp;''')
            _v = VFFSL(SL,"agent.max_status_date",True) # '$agent.max_status_date' on line 56, col 102
            if _v is not None: write(_filter(_v, rawExpr='$agent.max_status_date')) # from line 56, col 102.
            write('''<br/>
''')
        else: # generated from line 57, col 13
            write('''              Aucun probl\xc3\xa8me d\xc3\xa9tect\xc3\xa9<br/>
''')
        write('''\t    Intervalle de mesure&nbsp;:&nbsp;''')
        _v = VFFSL(SL,"str",False)(VFFSL(SL,"agent.period",True)) # '$str($agent.period)' on line 60, col 39
        if _v is not None: write(_filter(_v, rawExpr='$str($agent.period)')) # from line 60, col 39.
        write(''' s
    </div>

''')
        if VFFSL(SL,"agent.description",True) is not None and VFFSL(SL,"len",False)(VFFSL(SL,"agent.description",True)) != 0: # generated from line 63, col 3
            write('''  <!--<p>''')
            _v = VFFSL(SL,"agent.description",True) # '$agent.description' on line 64, col 10
            if _v is not None: write(_filter(_v, rawExpr='$agent.description')) # from line 64, col 10.
            write('''</p>-->
''')
        write('''</div> <!-- side -->

<div id="content">
''')
        for d in VFFSL(SL,"agent.data",True): # generated from line 69, col 1
            t = VFFSL(SL,"template_mapping",True)[VFFSL(SL,"d.__class__",True)]()
            t.data = VFFSL(SL,"d",True)
            write('''  ''')
            _v = VFFSL(SL,"str",False)(VFFSL(SL,"t",True)) # '$str($t)' on line 72, col 3
            if _v is not None: write(_filter(_v, rawExpr='$str($t)')) # from line 72, col 3.
            write('''
''')
        write('''</div> <!-- content -->

''')
        _v = VFFSL(SL,"foot",False)() # '$foot()' on line 76, col 1
        if _v is not None: write(_filter(_v, rawExpr='$foot()')) # from line 76, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_AgentPageTmpl= 'respond'

## END CLASS DEFINITION

if not hasattr(AgentPageTmpl, '_initCheetahAttributes'):
    templateAPIClass = getattr(AgentPageTmpl, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(AgentPageTmpl)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=AgentPageTmpl()).run()


