# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2011
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
###########################################################################

"""
Agent FreshClam
"""

from zephir.monitor.agentmanager.agent import Agent
from zephir.monitor.agentmanager.data import TableData, HTMLData
#from twisted.internet.utils import getProcessOutput
from zephir.monitor.agentmanager import status
from os.path import isfile
from zephir.monitor.agentmanager.util import status_to_img
import time

freshclam_file = '/var/log/clamav/freshclam-status.log'

class Freshclam(Agent):
    """
    Utilisateurs connectes
    """
    def __init__(self, name, **params):
        Agent.__init__(self, name, **params)
        self.status = 1
        self.table = TableData([
            ('status', 'état', {'align':'center'}, status_to_img),
            ('msg', 'message', {'align':'left'}, None)
        ])
        self.data = [self.table]

#    def init_data(self, archive_dir):
#        title1 = HTMLData("<h3>Mise à jour de ClamAV<h3>")
#        self.data.extend([title1, self.table])
#        Agent.init_data(self, archive_dir)

    def measure(self):
        ret = {}
        try:
            if isfile(freshclam_file):
                execfile(freshclam_file, {}, ret)
                if ret['STATUS'] == '0':
                    self.status = 1
                    status = 'On'
                    last_update = time.strftime("%d %b %Y %H:%M:%S", time.localtime(float(ret['DATE'])))
                    msg = 'Base antivirale mise à jour le %s' % last_update
                else:
                    self.status = 0
                    status = 'Off'
                    msg = ret['MSG']
            else:
                self.status = 0
                status = 'Off'
                msg = "Le fichier %s n'existe pas" % freshclam_file
        except Exception, e:
            self.status = 0
            status = 'Off'
            msg = "Impossible de lire %s : %s" % (freshclam_file, e)
        return [{'msg': msg, 'status': status}]

    def check_status(self):
        if self.status == 1 :
            return status.OK()
        return status.Error()

    def write_data(self):
        Agent.write_data(self)
        if self.last_measure is not None:
            self.table.table_data = self.last_measure.value
