# -*- coding: utf-8 -*-
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
#
# regen_certs.py
#
# script de regénération des certificats ssl
#
###########################################################################
from creole import cert
from pyeole.service import service_code_no_container
from creole.config import VIRTROOT, VIRTBASE
import os, glob

def regen_ssl_certs():
    # procédure à lancer et services à redémarrer pour regénérer les certificats
    ssl_serv = ['apache2', 'ead-server', 'ead-web', 'zephir', 'zephir_web',
                'eole-sso', 'sentinelle', 'nginx']
    try:
        for ssl_file in [cert.cert_file, cert.key_file]:
            if os.path.isfile(ssl_file):
                os.unlink(ssl_file)
        # lancement de la procédure de génération du certificat
        cert.gen_certs(regen=False)
    except:
        print "Erreur lors de la génération des certificats"
    else:
        # mise à jour des certificats dans tous les conteneurs
        container_dirs = glob.glob(os.path.join(VIRTROOT, '*', VIRTBASE, cert.cert_dir.lstrip('/')))
        for cont_dir in container_dirs:
            os.system('/bin/cp -a %s/* %s/' % (cert.cert_dir, cont_dir))
        # redémarrage des services utilisant les certificats
        for service in ssl_serv:
            try:
                service_code_no_container(service, 'restart')
            except:
                # une exception est levée si le service est désactivé
                pass
